<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- @author fabio.navarrete -->
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:p="http://primefaces.org/ui"
      xmlns:composite="http://java.sun.com/jsf/composite">

    <composite:interface>

        <composite:attribute name="geoLabel" required="true" />
        <composite:attribute name="geoId" required="true" />
        <composite:attribute name="geoComboId" required="true" />
        <composite:attribute name="selectedGeoProperty" />
        <composite:attribute name="geoComboData" />
        <composite:attribute name="dependentChangeGeoUpdate" />
        <composite:attribute name="orderTitle" default="Orden" />
        <composite:attribute name="orderByName" />
        <composite:attribute name="required" default="false"/>
        <composite:attribute name="renderComponent" default="true"/>
        <composite:attribute name="sortCodeImage"
                             default="/images/sortCode.png" />
        <composite:attribute name="disabled"
                             default="false" />
        <composite:attribute name="sortTextImage"
                             default="/images/sortText.png" />

        <composite:attribute name="onChangeGeoCombo"
                             method-signature="void action()" />
        <composite:attribute name="changeGeoComboOrder"
                             method-signature="void action()" />

    </composite:interface>

    <composite:implementation>
        <h:panelGrid columns="3" id="#{cc.attrs.geoId}" rendered="#{cc.attrs.renderComponent}">
            <h:selectOneMenu id="#{cc.attrs.geoComboId}" label="#{cc.attrs.geoLabel}" disabled="#{cc.attrs.disabled}"
                             value="#{cc.attrs.selectedGeoProperty}" required="#{cc.attrs.required}">
                <f:selectItems value="#{cc.attrs.geoComboData}" />
                <p:ajax process="@this" update="#{cc.attrs.dependentChangeGeoUpdate}" 
                        listener="#{cc.attrs.onChangeGeoCombo}" />
            </h:selectOneMenu>

            <p:message for="#{cc.attrs.geoComboId}" display="icon" id="geoComboMsg" />
            <p:commandLink update="btnOrdenGeoCombo, #{cc.attrs.geoComboId}"
                           title="#{cc.attrs.orderTitle}"
                           action="#{cc.attrs.changeGeoComboOrder}" id="btnOrdenGeoCombo"
                           ajax="true" process="@this">
                <p:graphicImage rendered="#{cc.attrs.orderByName}"
                                style="border: none" value="#{cc.attrs.sortCodeImage}" />
                <p:graphicImage rendered="#{!cc.attrs.orderByName}"
                                style="border: none" value="#{cc.attrs.sortTextImage}" />
            </p:commandLink>
        </h:panelGrid>
    </composite:implementation>

</html>